(function(angular, $, _) {

  angular.module('form_processor').controller('DelayedActionHandlerDialogCtrl', function InputDialogCtrl($scope, dialogService) {
    $scope.ts = CRM.ts(null);

    $scope.delayedActionHandler = {};
    //$scope.delayedActionHandler = angular.copy($scope.model.delayedActionHandler);
    $scope.delayedActionHandlers = $scope.model.delayedActionHandlers;
    $scope.formProcessor = $scope.model.formProcessor;
    $scope.fields = $scope.model.fields;
    
    angular.forEach($scope.delayedActionHandlers, function (delayedActionHandler, key) {
      delayedActionHandler.configuration = delayedActionHandler.default_configuration;
    	if (delayedActionHandler.name == $scope.model.action.delay) {
        delayedActionHandler.configuration = angular.copy($scope.model.action.delay_configuration);
    		$scope.delayedActionHandler = delayedActionHandler;
    	}
    });

    console.log($scope.delayedActionHandler.configuration);
    
    $scope.saveClick = function() {
      if ($scope.delayedActionHandler && $scope.delayedActionHandler.name) {
        $scope.model.action.delay = $scope.delayedActionHandler.name;
        $scope.model.action.delay_title = $scope.delayedActionHandler.title;
        $scope.model.action.delay_configuration = $scope.delayedActionHandler.configuration;
      } else {
        $scope.model.action.delay = null;
        $scope.model.action.delay_title = null;
        $scope.model.action.delay_configuration = null;
      }
    	dialogService.close('DelayedActionHandlerDialog', $scope.model);
    };
		
		$scope.cancelClick = function() {
    	dialogService.cancel('DelayedActionHandlerDialog');
    };
    
  });

})(angular, CRM.$, CRM._);